# Copyright (c) 2000-2001 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
__revision__ = "$Id: NarvalRC.py,v 1.2 2001/10/10 13:49:38 syt Exp $"

from os.path import normpath,join
from narval.lib import select_one, select_many, read_domtree_from_file
from narval import config

class NarvalRC:
    """
    class for configuration file handling
    """
    
    _DICT = {}

    def __init__(self):
        self.__dict__ = NarvalRC._DICT
        if not self.__dict__:
            NARVAL_HOME = config.get_home()
            rcpath = normpath(join(NARVAL_HOME,'data/narvalrc.xml'))
            self.black_list = {'actions':[], 'transforms':[], 'cookbook':[]}
            try:
                tree = select_one(read_domtree_from_file(rcpath), 'narvalrc')
                for n in select_many(tree, 'disable/actions-module/text()'):
                    self.black_list['actions'].append(n.data)
                for n in select_many(tree, 'disable/transforms-module/text()'):
                    self.black_list['transforms'].append(n.data)
                for n in select_many(tree, 'disable/cookbook/text()'):
                    self.black_list['cookbook'].append(n.data)
            except IOError:
                print 'No narval configuration file found, everything will be loaded.'
            
