"""ALDomletteReader XXX"""

#from narval.ext.pDomlette import *
from Ft.Lib.pDomletteReader import PyExpatReader,Handler
from xml.dom.ext import SplitQName
from Ft.Lib.pDomlette import Attribute

class ALHandler(Handler):
    def startElement(self,name,attribs):
        if self._force8Bit:
            name = self._encoder(name)
            new_attribs = {}
            for k in attribs.keys():
                new_attribs[self._encoder(k)] = self._encoder(attribs[k])
            attribs = new_attribs
        (name, qname, nsattribs) = self._handleStartElementNss(name, attribs)
        if self._processIncludes:
            self._handleIncludes(name, qname, nsattribs)
            if self._includeDepth: return
        namespace = name[0]
        local = name[1]
        prefix = SplitQName(qname)[0]
        self._completeTextNode()
##        new_element = Element(self._ownerDoc, namespace, local, prefix)
        new_element = self._ownerDoc.createElementNS(name[0],qname)
        for attr_qname in nsattribs.getQNames():
            (attr_ns, attr_local) = nsattribs.getNameByQName(attr_qname)
            attr_prefix = SplitQName(attr_qname)[0]
            attr = Attribute(self._ownerDoc, attr_ns, attr_local, attr_prefix)
            attr.value = nsattribs.getValueByQName(attr_qname)
            attr.ownerElement = new_element
            new_element.attributes[(attr_ns, attr_local)] = attr
        new_pstate = self._preserveStateStack[-1]
        for (uri, local, strip) in self._stripElements:
            if (uri, local) in [(new_element.namespaceURI,
                                 new_element.localName), ('', '*'),
                                (new_element.namespaceURI, '*')
                                ]:
                new_pstate = not strip
                break
        self._preserveStateStack.append(new_pstate)
        self._nodeStack.append(new_element)
        if self._indexStringValues: new_element.stringValue = ""
        return

class ALDomletteReader(PyExpatReader):
    HandlerClass = ALHandler

