# Copyright (c) 2000-2001 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

"""ActionElement module"""

__revision__ = "$Id: ActionElement.py,v 1.17 2001/08/10 12:14:38 alf Exp $"


from narval.lib import *
from narval.bibal import *

from ALDomAbstraction import ALElement
from Prototype import Prototype

class ActionElement(ALElement) :
    """ActionElement XXX"""

    # Element methods overriden ################################################

    def __repr__(self):
        return "<ActionElement Node at %s: %d attributes and %d children>" % \
               ( id(self), len(self.attributes), len(self.childNodes) )

    # ALElement interface ######################################################

    def unlink(self) :
        self.inputs = {}
        self.outputs = {}
        self.init = false
    
    def link(self) :
        if self.init : return
        for node in self.childNodes:
            name = node.nodeName
            matches = None
            # input
            if name == 'input' :
                matches = []
                self.inputs[node] = matches
            # outputs
            elif name == 'output' :
                matches = []
                self.outputs[node] = matches
            if matches is not None:
                for c in node.childNodes:
                    if c.nodeName == 'match':
                        matches.append(c.firstChild.data)
        self.init = true

    # Action element methods ###################################################

    def get_inputs(self) :
        self.link()
        return Prototype(self.inputs.keys())

    def get_outputs(self) :
        self.link()
        return Prototype(self.outputs.keys())
    
