# Copyright (c) 2001 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307
# USA.

"""
Horn Model
"""

__revision__ = "$Id: HornModel.py,v 1.6 2001/10/05 11:01:38 syt Exp $"

from Observer import Observable
import Queue
from narval.lib import FALSE,TRUE

#
# HornModel
#

class HornModel(Observable):
    """
    Data needs by Horn, also using borg pattern
    """

    _DICT= {}

    def __init__(self):
        self.__dict__ = self._DICT
        
        if not self.__dict__:
            Observable.__init__(self)
            # use a queue to execute functions
            self.queue = Queue.Queue(0)
            # narval himself, None when not connected (local)
            self.narval = None


    def set_narval(self, narval):
        self.narval = narval
        self.notify_observers()

    
