# Copyright (c) 2001 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307
# USA.

"""
HornRPC
"""

__revision__ = "$Id: HornRPC.py,v 1.9 2001/10/08 16:13:45 syt Exp $"

from narval import RpcServer

class HornRpcHandler(RpcServer.RequestHandler):
    """
    Horn RPC handler using singleton 'pattern'
    """
    _DICT_ = {}

    def __init__(self):
        self.__dict__ = self._DICT_

    def start(self,request,client_adress,data):
        RpcServer.RequestHandler.__init__(self,request,client_adress,data)

    EXPORTED_METHODS = {
        # memory listener
        'addElement':   'memory',
        'removeElement':    'memory',
        'replaceElement':   'memory',
        'getElementList': 'memory',
        'getElementsList':'memory',
        # plan listener
        'fireTransition':   'plan',
        'transitionStatusChanged':  'plan',
        'stepStatusChanged':    'plan',
        'planStatusChanged':    'plan',
        'instanciateRecipe':    'plan',
        'planRemoveElement':    'plan',
        'planAddElement':   'plan',
        # engine listener
        'postQueueEvent':   'engine',
        'popQueueEvent':    'engine',
        'postSchedulerEvent':   'engine',
        'popSchedulerEvent':    'engine'
        }
    
    
    def call(self, method, params) :
        # RPC handler must have references to objects whose methods are shared,
        # and define the EXPORTED_METHODS dictionnary which lists the shared
        # methods and gives the objects which provide these methods.
        try:
            from HornModel import HornModel
            HornModel().queue.put((self.EXPORTED_METHODS[method],method,params))
        except Exception, e :
            print 'Error: %s in %s when calling method %s with params %s' \
                  %(str(e), self.__class__, method, str(params))
        except KeyError :
            print '*-'*20
            print 'RPC call to undefined/forbidden method',method,params
        return ()
