# Copyright (c) 2001 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307
# USA.

"""
Observer Interface and Observable parent class
"""

__revision__ = "$Id: Observer.py,v 1.5 2001/10/09 10:57:04 syt Exp $"

class Observable :

    def __init__(self) :
        self.__observers = []
        self.changes = []
        from string import split
        self.__id = split(str(self.__class__), '.')[-1]
        
    def attach_observer(self,observer):
        if observer not in self.__observers :
            self.__observers.append(observer)

    def detach_observer(self,observer):
        i = 0
        for o in self.__observers:
            if o.__dict__ is observer.__dict__:
                self.__observers.pop(i)
                break
            i += 1
            
    def notify_observers(self) :
        """
        if the observable class name is A (or module.A), this method will call
        A_update method on all observers
        """
        func = 'o.%s_update(self,self.changes)'%self.__id
        for o in self.__observers :
            try:
                eval(func)
            except AttributeError, e:
                print "%s doesn't have %s_update method"%(o.__class__, self.__id)
        self.changes = []


#class ObserverInterface :
#    def observable_update(self, observable, changes):
#        pass
