# Copyright (c) 2000-2001 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

"""Preferences Manager"""

__revision__ = "$Id: PrefManager.py,v 1.3 2001/10/08 16:13:45 syt Exp $"

from gtk import *
from narval.lib import *
from os.path import normpath,normcase,join
from string import strip

from PrefController import PrefController
from PrefModel import PrefModel
from PrefView import PrefView
from MemoryView import MemoryView
from HornView import HornView

class PrefManager:
    """
    PreferencesManager using Borg pattern
    """

    _DICT_ = {}

    def __init__(self):
        self.__dict__ = self._DICT_

        if not self.__dict__ :
            # start controller
            controller = PrefController()
            
            # start model and attach view
            PrefModel().attach_observer(HornView())
            PrefModel().attach_observer(PrefView())
            PrefModel().attach_observer(MemoryView())
            PrefModel().set_pref(normpath(join(config.get_home(),'data/horn_preferences.xml')))

