# Copyright (c) 2000-2001 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

"""RPC Service"""

from narval import RpcServer

# Handler ######################################################################

class RpcHandler(RpcServer.RequestHandler):
    """RpcHandler"""

    Engine = None
    ComService = None
    
    EXPORTED_METHODS = {
        # listeners
        'addRemotePlanListener':     'ComService',
        'addRemoteMemoryListener':   'ComService',
        'removeRemotePlanListener':  'ComService',
        'removeRemoteMemoryListener':'ComService',
        'addRemoteEngineListener':   'ComService',
        'removeRemoteEngineListener':'ComService', 
        # memory interface
        'getMemory':      'Engine',
        'getElement':     'Engine',
        'addElement':     'Engine',
        'removeElement':  'Engine',
        'replaceElement': 'Engine',
        'startPlan':      'Engine',
        'getElementList': 'Engine',
        'getElementsList':'Engine',
        # messaging
        'postMessage':   'Engine',
        # debug
        'debugStepOneStep':'Engine',
        'debugSuspend':    'Engine',
        'debugContinue':   'Engine',
        # remote control
        'saveRecipes':   'Engine',
        'saveTransforms':'Engine',
        'shutdown':      'Engine'
        }

# Server #######################################################################

from narval.services.BaseService import BaseSocketService

class RpcService(BaseSocketService):
    """RpcService"""

    def __init__(self,port,engine,comservice) :
        RpcHandler.Engine = engine
        RpcHandler.ComService = comservice
        BaseSocketService.__init__(self,port,RpcHandler,RpcHandler.rpc+' RpcService')

