# Copyright (c) 2000-2001 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

"""Soap module implements the Soap RPC service"""

__revision__ = "$Id: Soap.py,v 1.11 2001/04/28 12:26:44 nico Exp $"

import soapserver,soaplib
import SocketServer,socket
import threading
import select

# Handler ######################################################################

class NarvalSoapHandler(soapserver.RequestHandler):
    """SOAP handler"""

    Engine = None
    ComService = None
    
    EXPORTED_METHODS = {
        # listeners
        'addRemotePlanListener':     'ComService',
        'addRemoteMemoryListener':   'ComService',
        'removeRemotePlanListener':  'ComService',
        'removeRemoteMemoryListener':'ComService',
        'addRemoteEngineListener':   'ComService',
        'removeRemoteEngineListener':'ComService', 
        # memory interface
        'getMemory':     'Engine',
        'getElement':    'Engine',
        'addElement':    'Engine',
        'removeElement': 'Engine',
        'replaceElement':'Engine',
        'startPlan':     'Engine',
        # messaging
        'postMessage':   'Engine',
        # debug
        'debugStepOneStep':'Engine',
        'debugSuspend':    'Engine',
        'debugContinue':   'Engine',
        # remote control
        'saveRecipes':   'Engine',
        'saveTransforms':'Engine',
        'shutdown':      'Engine'
        }


    def call(self,method,params):
        try:
            object = getattr(self,self.EXPORTED_METHODS[method])
            if object :
                result = apply(getattr(object,method), params)
                if result != None:
                    return (result,)
            else :
                print 'SoapService error: No',object,'to call'
        except Exception, e:
            print 'Error: %e in %s when calling method %s with params %s' \
                  % (str(e), self.__class__, method, str(params))
        except KeyError:
            print '*-'*20
            print 'SOAP call to undefined/forbidden method',method,params
        return ()
        
# Server #######################################################################

from narval.services.BaseService import BaseSocketService

class SoapService(BaseSocketService):
    """SOAP service"""

    def __init__(self,port,engine,comservice) :
        NarvalSoapHandler.Engine = engine
        NarvalSoapHandler.ComService = comservice
        BaseSocketService.__init__(self,port,NarvalSoapHandler,'SOAPService')
