# Copyright (c) 2000 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


__revision__ = "$Id: Basic.py,v 1.50 2001/10/15 15:09:25 alf Exp $"

from narval.lib import *
import copy, os
import urllib, urlparse, string
import traceback
# added by zzzzz
import re, string

MOD_XML = """<module name='Basic'>"""

# No OPeration #################################################################

def NOP_f(args) :
    return args.ownerDocument.createElementNS('','outputs')

MOD_XML = MOD_XML + \
          """<action name='NOP' func='NOP_f'>
           <description lang='en'>the very usefull NO operation !</description>
          </action>
          """

# Execute a command ############################################################

def command_f(args) :
    command = select_one(args,'command/text()').data
    os.system(command)
    return args.ownerDocument.createElementNS('','outputs')

MOD_XML = MOD_XML + \
          """<action name='command' func='command_f'>
           <description lang='en'>execute a system command</description>
          <input use='yes'><match>command</match>
           <description lang='en'>the command to execute</description></input>
          </action>
          """



# Read a file ##################################################################

def read_raw_file_f(args):
    # define doc"
    doc = args.ownerDocument
    # create document with root outputs
    outputsNode = doc.createElementNS('','outputs')
    url = select_one(args,'url/text()').data

    try:
        # read data
        f = urllib.urlopen(normalize_url(url)[0])
        # remove unacceptable \0 character from read data -- happens with yahoo
        tempdata = f.read()
        data = re.sub('\x00','',tempdata)
        f.close()
        
        # dom accepts only utf-8 and narval wants utf-8
        data = latin1_to_utf8(data)

        # document
        documentNode = doc.createElementNS('','raw-file')
        documentNode.setAttributeNS('','type','read')
        outputsNode.appendChild(documentNode)
        # path
        urlNode = doc.createElementNS('','url')
        urlNode.appendChild(doc.createTextNode(url))
        documentNode.appendChild(urlNode)
        # content
        dataNode = doc.createElementNS('','data')
        
        dataNode.appendChild(doc.createTextNode(data))
        documentNode.appendChild(dataNode)
      
    except IOError:
        Err = doc.createElementNS('','error')
        Err.setAttributeNS('','type','No such url '+url)
        outputsNode.appendChild(Err)
    
    return outputsNode

MOD_XML = MOD_XML + \
          """<action name='read_file' func='read_raw_file_f'>
          <description lang='en'>read a raw file</description>
          <input id='to-read'><match>url/text()</match>
          <description lang='en'>url locating the file to read</description></input>
          <output><match>raw-file/url/text()</match>
                  <match>raw-file/data/text()</match>
          <description lang='en'>xml element containing the raw file in its data child</description>
          </output>
          </action>
          """

# Read an XML file #############################################################

def read_xml_file_f(args):
    doc = args.ownerDocument
    outputsNode = doc.createElementNS('','outputs')
    url = select_one(args,'url/text()').data
    try:
        proxy=select_one(args,'proxy')
        from Http import export_http_proxy
        export_http_proxy(proxy)
    except SelectException:
        pass

    try:
        # read data
        # XXXFIXME: rajouter Proxies et URLOpener
        f = urllib.urlopen(normalize_url(url)[0])
        data = f.read()
        f.close()
        try:
            outputsNode.appendChild(doc.importNode(
                read_domtree_from_string(data).documentElement,1))
        except Exception,e:
            traceback.print_exc()
            # try correcting stuff
            if data[:5] == '<?xml':
                import string,re
                if string.find(data[:80],'encoding')==-1:
                    p = string.find(data,'?>')
                #    data = data[:p]+ ' encoding="iso-8859-1" ' + data[p:]
                    data = data[:p]+ ' encoding="utf-8" ' + data[p:]
                    print data[:80]
                else:
                    raise e
            else :
                data = '<?xml version="1.0" encoding="iso-8859-1"?>\n'+data
            outputsNode.appendChild(doc.importNode(
                read_domtree_from_string(data).documentElement,1))
        StripXml(outputsNode)
    except IOError:
        Err = doc.createElementNS('','error')
        Err.setAttributeNS('','type','No such url '+url)
        outputsNode.appendChild(Err)
    return outputsNode

MOD_XML = MOD_XML + """
<action name='read_xml_file' func='read_xml_file_f'>
<description lang='en'>read a valid xml file</description>
<input><match>url/text()</match>
<description lang='en'>url locating the file to read</description></input>
<input optional="yes"><match>proxy[@type="http"]</match>
<description lang="en">proxy element, for page requests</description></input>
<output id='to-read'>
<description lang='en'>xml element which represents the readen file
(it's root element depends on the file you have just read!)</description>
</output>
</action>
          """

# Write a file #################################################################

def write_raw_file_f(args) :
    url = select_one(args,'raw-file/url/text()').data
    url, url_tuple = normalize_url(url)
    data = select_one(args,'raw-file/data').firstChild.data
    if url_tuple[0] == 'file' :
	if url_tuple[2][0]=='/' and url_tuple[2][2] == ':':
            fname = url_tuple[2][1:]
        else:
            fname = url_tuple[2]
        f = open(fname,'w')
        f.write(data)
        f.close()
    else :
        raise Exception("Can't write file at that URL %s" % url)
    return args.ownerDocument.createElementNS('','outputs')

MOD_XML = MOD_XML + \
          """<action name='write_file' func='write_raw_file_f'>
           <description lang='en'>write a raw file</description>
          <input>
          <match>raw-file/url/text()</match>
          <match>raw-file/data/text()</match>
           <description lang='en'>url locating the file to write</description>
           </input>
          </action>
          """

# Write an XML file ############################################################

def write_xml_file_f(args) :
    # get the url where the file will be written
    url = select_one(args,'url/text()').data
    url, url_tuple = normalize_url(url)
    # get the data to be written in the file
    data = select_one(args,'*[@input-id="to-write"]')

    # get the encoding of the file (optional, default is UTF-8)
    try:
        encoding = select_one(args,'encoding/text()').data
    except SelectException:
        encoding="UTF-8"
         
#     # get the doctype of the file (optional)
#     try:
#         systemId = select_one(args,'xml-file/doctype/systemid/text()').data
#     except SelectException:
#         systemId = ""
#     try:
#         publicId = select_one(args,'xml-file/doctype/publicid/text()').data
#     except SelectException:
#         publicId = ""
#     if systemId=="":
#         # publicId can't be defined alone (cf. XML Spec)
#         publicId = ""

#     # Builds a doctype for the file
#     docType = implementation.createDocumentType(data.localName,
#                                                 publicId, systemId)
#     # Builds a document for the file
#     document = implementation.createDocument('', '', docType)
#     # Adds the data to be saved as child of this document
#     document.appendChild(document.importNode(data,1))
    
    # Opens the file and saves the document
    if url_tuple[0] == 'file' :
	if url_tuple[2][0]=='/' and url_tuple[2][2] == ':':
            fname = url_tuple[2][1:]
        else:
            fname = url_tuple[2]
        write_domtree_to_file(data,fname,encoding)
    else :
        raise Exception("Can't write file at that URL %s" % url)
    return args.ownerDocument.createElementNS('','outputs')

MOD_XML = MOD_XML + \
          """<action name='write_xml_file' func='write_xml_file_f'>
           <description lang='en'>write an xml file</description>
          <input><match>url/text()</match>
           <description lang='en'>url locating the file to write</description></input>
          <input optional='yes'><match>encoding/text()</match>
           <description lang='en'>encoding to use in the file</description></input>
          <input id='to-write'>
           <description lang='en'>xml element which represents the file to write</description>
          </input>
          </action>
          """

# Write an HTML file ###########################################################

def write_html_file_f(args) :
##    from xml.dom import implementation
    from narval.dom.ALDomAbstraction  import ALDocument
    try:
        from xml.dom.ext.XHtml2HtmlPrinter import XHtml2HtmlPrintVisitor
    except:
        from narval.ext.XHtml2HtmlPrinter import XHtml2HtmlPrintVisitor
    from xml.dom.ext.Printer import PrintWalker
    # get the url where the file will be written
    url = select_one(args,'html-file/url/text()').data
    url, url_tuple = normalize_url(url)
    # get the data to be written in the file
    dataNodes = select_many(args,'html-file/data/*')
    # get the encoding of the file (optional, default is UTF-8)
    try:
        encoding = select_one(args,'html-file/encoding/text()').data
    except SelectException:
        encoding="UTF-8"
    
    # Builds a doctype for the file (neither systemId nor publicId is
    # necessary, the printer will insert default ones)
    ##docType = implementation.createDocumentType('xhtml','', '')
    
    # Opens the file and saves the document
    if url_tuple[0] == 'file' :
	if url_tuple[2][0]=='/' and url_tuple[2][2] == ':':
            fname = url_tuple[2][1:]
        else:
            fname = url_tuple[2]

        f = open(fname,'w')
        visitor = XHtml2HtmlPrintVisitor(f, encoding, '    ')
        for dataNode in dataNodes :
##            # Builds a document,
##            document = implementation.createDocument('', '', docType)
##            # then merge the data.
##            document.appendChild(document.importNode(dataNode,1))
            
            document = ALDocument()
            document.appendChild(document.createElementNS('','xhtml'))
            document.appendChild(document.importNode(dataNode,1))
            PrintWalker(visitor, dataNode).run()
        f.write('\n')
        f.close()
    else :
        raise Exception("Can't write file at that URL %s" % url)
    return args.ownerDocument.createElementNS('','outputs')

MOD_XML = MOD_XML + \
          """<action name='write_html_file' func='write_html_file_f'>
           <description lang='en'>write an html file</description>
          <input><match>html-file/url/text()</match>
          <match>html-file/data/*</match>
           <description lang='en'>html-file node contain url locating the file to write
           and the data to write in the file</description></input>
          </action>
          """

# Append text to a document ####################################################

def append_text_to_document_f(args) :
    document = select_one(args,'document').cloneNode( DEEP_COPY )
    content = select_one(document,'content')
    content.appendData = select_one(args,'text/value').data

# FIXME: so empty outputs won't match the prototype!

    return args.ownerDocument.createElementNS('','outputs')

# XXX problem with trailing '\n'?

MOD_XML = MOD_XML + \
          """<action name='append_text_to_document'
          func='append_text_to_document_f'>
           <description lang='en'>append some text to a document</description>
          <input><match>document</match>
           <description lang='en'>the document</description></input>
          <input><match>text</match>
           <description lang='en'>the text</description></input>
          <output><match>document</match>
           <description lang='en'>the document with the text appended</description></output>
          </action>
          """

# Append text to a file ########################################################

def append_text_to_file_f(args) :
#    filepath = select_one(args,'file/path/text()').data
    filepath = select_one(args,'file/path/text()').data
    text_val = select_one(args,'text/value/text()').data
    f = open(filepath,'a')
    f.write(text_val+'\n')
    return args.ownerDocument.createElementNS('','outputs')

MOD_XML = MOD_XML + \
          """<action name='append_text_to_file' func='append_text_to_file_f'>
           <description lang='en'>append some text to a file</description>
          <input><match>url</match>
           <description lang='en'>url locating the file to write</description></input>
          <input><match>text</match>
           <description lang='en'>text to append</description></input>
          </action>
          """

# Search a match to regular expressions in an element ##########################

REGEXER_ERR_MSG = """Could not find string to match, check that you do
<regexp-set match='foo/bar'><rule/></regexp-match> with
<baz><foo><bar>your text string</bar></foo><dotcom/></baz> and mind
the baz/foo/bar and foo/bar difference."""

def regexer_f(args) :
    from re import search,IGNORECASE
    # init
    regexp_set = select_one(args,'regexp-set')
    regexp_target = select_one(args,'*[@input-id="regexp-target"]')
    doc = args.ownerDocument
    outputs_node = doc.createElementNS('','outputs')
    regexp_result_node = false

    # Let's get the string to test...
    try:
        path = regexp_set.getAttributeNS('','match')
        st = select_one(regexp_target,path).data
    except SelectException:
        error = doc.createElementNS(AL_NS,'error')
        error.appendChild(doc.createTextNode(REGEXER_ERR_MSG))
        outputs_node.appendChild(error)
        return outputs_node

    # Apply each rule until we find a match.
    for rule_node in select_many(regexp_set,'rule') :
        regexp = rule_node.firstChild.data
        if rule_node.getAttributeNS('','ignore-case') == 'yes' :
            m = re.compile(regexp,re.I).match(st)
            #m = re.search(regexp,st,IGNORECASE)
        else :
            m = re.compile(regexp).match(st)
            #m = re.search(regexp,st)
        if m :
            regexp_result_node = doc.createElementNS('','regexp-result')
            regexp_result_node.setAttributeNS('','rule-id',
                                              rule_node.getAttributeNS('','id'))
            outputs_node.appendChild(regexp_result_node)
            
            for name,value in m.groupdict().items() :
                group_node = doc.createElementNS('','group')
                group_node.setAttributeNS('','name',name)
                value_node = doc.createTextNode(value)
                group_node.appendChild(value_node)
                regexp_result_node.appendChild(group_node)
            break
    # not match found: error
    if not regexp_result_node :
        error_node = doc.createElementNS('','error')
        error_node.setAttributeNS('','type','No rule matched.')
        error_node.appendChild(args)
        outputs_node.appendChild(error_node)
    # return
    return outputs_node

MOD_XML = MOD_XML + \
          """<action name='regexer' func='regexer_f'>
           <description lang='en'>regular expression matcher</description>
          <input><match>regexp-set[@match and rule/text()]</match>
           <description lang='en'>regular expression</description></input>
          <input id='regexp-target'>
           <description lang='en'>string to process</description></input>
          <output><match>regexp-result</match>
           <description lang='en'>result structure</description></output>
          </action>
          """
# Send a message ###############################################################

def send_msg_f(args) :
    doc = args.ownerDocument
    outputs = doc.createElementNS('','outputs')
    
    msg = select_one(args,'message')
    print 'Sending message',select_one(msg,'@eid/text()').data, \
          select_one(msg,'header/to/text()').data
    msg.removeAttributeNS(AL_NS,'eid')
    msg.removeAttributeNS(AL_NS,'from_plan')
    msg.removeAttributeNS(AL_NS,'from_step')
    from_address = select_one(args,'agent-def/address/text()').data
    to_address = select_one(msg,'header/to/text()').data
    timestamp = select_one(msg,'@timestamp/text()').data
    msg.removeAttributeNS(AL_NS,'timestamp')
    headers_node = select_one(msg,'header')
    from_node = msg.ownerDocument.createElementNS('','from')
    time_node = msg.ownerDocument.createElementNS('','timestamp')
    headers_node.appendChild(from_node)
    headers_node.appendChild(time_node)
    from_node.appendChild(msg.ownerDocument.createTextNode(from_address))
    time_node.appendChild(msg.ownerDocument.createTextNode(timestamp))
    from narval import RpcServer
    try:
        other = RpcServer.Server("http://"+to_address)
        other.postMessage(element_to_string(msg))
    except:
        err = doc.createElementNS('','error')
        err.setAttributeNS('','address',str(to_address))
        err.setAttributeNS('','type','unreachable host')
        outputs.appendChild(err)
    
    return outputs

MOD_XML = MOD_XML + \
          """<action name='send_message' func='send_msg_f'>
          <description lang='en'>send a message to another Narval</description>
          <input id='message' use='yes'><match>message/@type='outgoing'</match>
          <description lang='en'>message to send</description></input>
          <input><match>agent-def[@type='self']</match>
          <description lang='en'>structures which describes remote Narval</description>
          </input>
          </action>
          """

def download_dataunit_f(args):
    myhtmllib  = load_extension_module('html', 'myhtmllib')
    doc = args.ownerDocument
    output = doc.createElementNS('', 'outputs')
    list_error=[]
    try:
        im_filter = select_one(s_u, 'image-filter')
    except:
        im_filter = None
    for s_u in select_many(args, 'data-unit'):
        data = ''
        data_n = None
        try:
            data_n = select_one(s_u, 'data')
            txt_n = select_one(data_n, 'text()')
            data = txt_n.data
            data_n.removeChild(txt_n)
        except Exception,e:
            pass
            #print e
        url = select_one(s_u, 'url/text()').data
        # image filter
        if im_filter:
            ext_list = re.split('[.*]', url[-5:])
            end = len(ext_list)-1
            if ext_list[end] == 'jpg' or \
               ext_list[end] == 'png' or \
               ext_list[end] == 'gif':
                print 'url is a picture'
                continue
        try:
            txt_data = myhtmllib.parse_html_url(url, debug=0)
            from cStringIO import StringIO
            data = StringIO(txt_data.getvalue() + utf8_to_latin1(data))

        except Exception, e:
            # 'Error, Pass this url.'
            list_error.append(s_u)
            continue
        if not data_n:
            data_n = doc.createElementNS('', 'data')
            s_u.appendChild(data_n)
        data_txt = doc.createTextNode(data.getvalue())
        data_n.appendChild(data_txt)
        output.appendChild(s_u)
    # FIXME error handling
#    if len(list_error) != 0:
#        errors = doc.createElementNS('','error')
#        for s_u in list_error[:]:
#            errors.appendChild(s_u)
#        output.appendChild(errors)
    return output

MOD_XML = MOD_XML + """
<action name='download_data-unit' func='download_dataunit_f'>
<description lang='en'>take a data-unit element with an url child, return the data-unit
element with its data child concatened with the content downloaded from the url
</description>
<input use='yes' list='yes'>
<match>data-unit[url]</match>
<description lang='en'>data-unit element with data to download from its url child
</description>
</input>
<input optional='yes'><match>image-filter</match>
<description lang='en'>filters images if this element is found</description>
</input>
<output list='yes'>
<match>data-unit[data]</match>
<description lang='en'>completed data-unit</description>
</output>
</action>
"""


# Test #########################################################################

MOD_XML = MOD_XML + "</module>"

if __name__ == "__main__" :
    from xml.dom.ext.reader import Sax2
    print MOD_XML
    doc=Sax2.FromXml(MOD_XML)
    print doc.documentElement
