# Copyright (c) 2001 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, 

from narval.lib import *
import md5

ALXBEL_NS = 'http://www.logilab.org/narval'

MOD_XML = """<module name='Checksum'>"""

    
MOD_XML = MOD_XML + """
<action name='md5_checksum' func='md5_checksum_f'>
<description lang='en'>compute a md5 checksum on raw data</description>
<input outdates='yes' list='yes'><match>data-unit[data]</match>
<description lang='en'>data-unit element with data child containing text to hash
</description></input>
<output list='yes'><match>data-unit[@md5checksum]</match>
<description lang='en'>data-unit element with new/updated md5checksum attribut
</description></output>
</action>
"""
def md5_checksum_f(args):
    doc = args.ownerDocument
    outputs = doc.createElementNS('','outputs')
    for node in select_many(args,'data-unit'):
        data = select_one(node,'data/text()').data
        m = md5.new(data)
        new_digest = repr(m.digest())
        node.setAttributeNS('','md5checksum',new_digest)
        outputs.appendChild(node)
    return outputs


# Test #########################################################################

MOD_XML = MOD_XML + "</module>"

if __name__ == "__main__" :
    from xml.dom.ext.reader import Sax2
    print MOD_XML
    doc=Sax2.FromXml(MOD_XML)
    print doc.documentElement
